<?php
//Set API Key
$api_key = "set_your_api_key_here";
$foxycart_domain = "yourdomain.foxycart.com";


//Verification Function
function get_verification($var_name, $var_value, $var_code) {
	global $api_key;
	$encodingval = htmlspecialchars($var_code) . htmlspecialchars($var_name) . htmlspecialchars($var_value);
	return '||'.hash_hmac('sha256', $encodingval, $api_key).($var_value === "--OPEN--" ? "||open" : "");
}


//Get Old Cart From Cookie
$local_fc_cookie = $_COOKIE['local_fc_cookie'];
if (get_magic_quotes_gpc()) $local_fc_cookie = stripslashes($local_fc_cookie);
$fc = json_decode($local_fc_cookie);

//Get Old Cart From Cookie
$fcsid = $_GET['fcsid'];

//Debug
$debug = isset($_GET['debug']) ? $_GET['debug'] : 0;

//Die if invalid JSON
if (is_null($fc)) die("Invalid Local Cookie");

//Empty Cart
$url = "https://" . $foxycart_domain . "/cart?fcsid=" . $fcsid . "&output=json&empty=true";
$ch = curl_init();
curl_setopt($ch, CURLOPT_URL, $url);
curl_setopt($ch, CURLOPT_RETURNTRANSFER, 1);
$curlout = trim(curl_exec($ch));
if ($debug) echo "Empty Cart:\n" . $curlout;

//Each Product
$product_vars = array("name", "code", "image", "url", "quantity", "quantity_min", "quantity_max", "price", "weight", "shipto", "category", "sub_frequency");
$product_subs = array("sub_startdate", "sub_nextdate", "sub_enddate");

foreach ($fc->products as $product) {

	$url = "https://" . $foxycart_domain . "/cart?fcsid=" . $fcsid . "&output=json";
	$code = $product->code;
	foreach ($product as $key => $val) {

		//Base Names
		if (in_array($key, $product_vars)) {
			if ($key == "price") $val = $product->price_each;
			if ($key == "weight") $val = $product->weight_each;
			if ($val != '') $url .= "&" . urlencode(htmlspecialchars($key)) . "=" . urlencode(htmlspecialchars($val)) . get_verification($key, $val, $code);

		//Sub
		} elseif (in_array($key, $product_subs) && $val != "0000-00-00") {
			if ($val != '') $url .= "&" . $key . "=" . urlencode(htmlspecialchars($val)) . get_verification($key, $val, $code);

		//Options
		} elseif ($key == "options") {
			foreach ($val as $option_key => $option_val) {
				if ($option_val != '') $url .= "&" . urlencode(htmlspecialchars($option_key)) . "=" . urlencode(htmlspecialchars($option_val)) . get_verification($option_key, $option_val, $code);
			}
		}

	}

	//Add Item
	$ch = curl_init();
	curl_setopt($ch, CURLOPT_URL, $url);
	curl_setopt($ch, CURLOPT_RETURNTRANSFER, 1);
	$curlout = trim(curl_exec($ch));
	if ($debug) echo "\n\nAdd Item:\n$url\n" . $curlout;

}

//Coupons
if (isset($fc->coupons)) {
	foreach ($fc->coupons as $coupon_name => $coupon_value) {
		$url = "https://" . $foxycart_domain . "/cart?fcsid=" . $fcsid . "&output=json&coupon=" . urlencode($coupon_name);
		$ch = curl_init();
		curl_setopt($ch, CURLOPT_URL, $url);
		curl_setopt($ch, CURLOPT_RETURNTRANSFER, 1);
		$curlout = trim(curl_exec($ch));
		if ($debug) echo "\n\nAdd Coupon:\n" . $curlout;
	}
}

//Custom Fields
if (isset($fc->custom_fields)) {
	foreach ($fc->custom_fields as $key => $val) {
		$url = "https://" . $foxycart_domain . "/cart?fcsid=" . $fcsid . "&output=json&h:" . urlencode($key) . "=" . urlencode($val);
		$ch = curl_init();
		curl_setopt($ch, CURLOPT_URL, $url);
		curl_setopt($ch, CURLOPT_RETURNTRANSFER, 1);
		$curlout = trim(curl_exec($ch));
		if ($debug) echo "\n\nAdd Custom Field:\n" . $curlout;
	}
}

echo "Cart Rebuild Successful";
die;